<div class="account l-container-narrow u-margin-tb-50">
    <ng-container *ngIf="!isExtension">
    <h2 class="heading-main heading-main--pad-bottom">
        Register Security Key
    </h2>
    <div class="text--large u-margin-tb-20">
        Set up a hardware device as a second factor to sign in.
    </div>
    <div *ngIf="!mfaRequired" class="register-step__feedback">
        <div class="u-margin-b-15">
            Not all browsers support security keys. Therefore, we require that you set up a TOTP authentication app first.
            That way you'll always be able to sign in - even when you're using an unsupported browser.
        </div>
    </div>
    <p *ngIf="regSuccess && !u2fIsBegun" class="text--large u-margin-tb-20">
        Your device has been successfully registered.
    </p>
    <div *ngIf="!u2fIsBegun">
        <button class="button button--primary" [disabled]="!mfaRequired" (click)="beginU2fReg.emit()">
            Set up new device
        </button>
    </div>
    <div *ngIf="!mfaRequired" class="text--large u-margin-tb-20">
        You need to register a TOTP authentication app before you can set up a device.
    </div>
    <div *ngIf="u2fIsBegun">
        <p *ngIf="!awaitingResponse" class="text--large u-margin-b-20">Please pick a name for your device.</p>
        <p *ngIf="awaitingResponse" class="text--large u-margin-b-0">Trying to communicate with your device. Plug it in (if needed), and press the button on the device now.</p>
        <form [ngrxFormState]="u2fForm" (submit)="generateU2f.emit()">
                <app-text-field
                [isFormSubmitted]="u2fForm.isSubmitted"
                [ngrxFormControl]="u2fForm.controls.name"
                ></app-text-field>
                <ul *ngIf="u2fErrors" class="form-field__error-list">
                    <li *ngFor="let u2fError of u2fErrors" class="form-field__error">
                    {{ u2fError }}
                    </li>
                </ul>
                <button class="button button--primary" (click)="generateU2f.emit()">
                    Register device
                </button>
        </form>
    </div>
    </ng-container>
    <div class="key_list_container" *ngIf="u2fList.length > 0">
        <div class="list_title"><strong>Security keys</strong></div>
        <div class="key_headings">
            <div><strong>Name</strong></div>
            <div><strong>Last used</strong></div>
        </div>
        <div class="key_row" *ngFor="let key of u2fList"> 
            <div class="cell">
                <div
                class="key-name"
                placement="top"
                tooltip="{{ key.name }}"
                [display]="!tooltipDisabled"
                (mouseover)="checkIfTooltipIsNecessary($event, 130)"
                >
                    <span>{{ key.name }}</span>
                </div>
            </div>
            <div class="cell">
                <div>{{ key.last_used ? (key.last_used | date: 'MM-dd-yyyy') : 'Not yet used' }}</div>
            </div>
            <div class="button_cell">
                <button
                class="button button--text button--text-danger button--text-center"
                type="button"
                (click)="deleteU2fKey.emit(key.id)"
                >
                    <strong>Delete</strong>
                </button>
            </div>
        </div>
    <div>
</div>


